<template>
    <Page>
        <ActionBar title="Open Smart Fitness">
            <StackLayout orientation="horizontal"
                         ios:horizontalAlignment="center"
                         android:horizontalAlignment="center">
                <Label :text="appName"></Label>
            </StackLayout>
        </ActionBar>
        <ScrollView>
            <StackLayout class="home-panel p-20">

                <!--<Button text="¿Bluetooth activo?" @tap="isBluetoothEnabled" class="btn btn-primary" />-->

                <!--<Button text="Permisos" @tap="requestBluetoothPermission" class="btn btn-primary" />-->

                <Button text="Escanear" @tap="scan" class="btn btn-primary" v-if="!peripheraluuid" />

                <Button text="Conectar" @tap="connect" class="btn btn-primary" v-if="peripheraluuid && !listening && !connecting"/>

                <Label text="Cadencia(Rpm)" class="title" v-if="listening"></Label>

                <Label :text="cadence" class="number" v-if="listening"></Label>

                <StackLayout class="home-panel p-20" v-if="listening">
                    <StackLayout height="700px">
                        <RadRadialGauge>
                            <RadialScale v-tkRadialGaugeScales minimum="0"
                                         maximum="150" radius="0.90">
                                <ScaleStyle v-tkRadialScaleStyle majorTicksCount="7"
                                            minorTicksCount="9" lineThickness="0"
                                            labelsCount="7" ticksOffset="0" />
                                <RadialBarIndicator v-tkRadialScaleIndicators
                                                    minimum="0" maximum="20" location="0.97">
                                    <BarIndicatorStyle
                                            v-tkRadialBarIndicatorStyle fillColor="#dddddd" />
                                </RadialBarIndicator>
                                <RadialBarIndicator v-tkRadialScaleIndicators
                                                    minimum="20" maximum="50" location="0.97">
                                    <BarIndicatorStyle
                                            v-tkRadialBarIndicatorStyle fillColor="#9DCA56" />
                                </RadialBarIndicator>
                                <RadialBarIndicator v-tkRadialScaleIndicators
                                                    minimum="50" maximum="80" location="0.97">
                                    <BarIndicatorStyle
                                            v-tkRadialBarIndicatorStyle fillColor="#F0C44D" />
                                </RadialBarIndicator>
                                <RadialBarIndicator v-tkRadialScaleIndicators
                                                    minimum="80" maximum="100" location="0.97">
                                    <BarIndicatorStyle
                                            v-tkRadialBarIndicatorStyle fillColor="#E27633" />
                                </RadialBarIndicator>
                                <RadialBarIndicator v-tkRadialScaleIndicators
                                                    minimum="100" maximum="150" location="0.97">
                                    <BarIndicatorStyle
                                            v-tkRadialBarIndicatorStyle fillColor="#A7010E" />
                                </RadialBarIndicator>
                                <RadialNeedle v-tkRadialScaleIndicators :value="cadence" />
                            </RadialScale>
                        </RadRadialGauge>
                    </StackLayout>
                </StackLayout>

                <!--<Label :text="timestamp" class="message" v-if="listening"></Label>-->

                <Button text="Desconectar" @tap="disconnect" class="btn btn-primary" v-if="listening"/>

            </StackLayout>
        </ScrollView>
    </Page>
</template>

<script>
    import Vue from 'nativescript-vue';
    import bluetooth from 'nativescript-bluetooth';
    import RadGauge from "nativescript-ui-gauge/vue";
    Vue.use(RadGauge);

    export default {

        data() {

            return {
                appName: 'Open Smart Fitness',
                serviceuuid: 'ad2b0316-4851-48a9-aebd-42bedc3654bd',
                peripheraluuid: null,
                characteristicuuid: '45d4f28f-b24a-4619-83d1-be0a2316577b',
                listening: false,
                connecting: false,
                cadence: 0,
                timestamp: 0

            }
        },
        mounted: function () {
        },
        methods: {

            isBluetoothEnabled() {

                var self = this;

                bluetooth.isBluetoothEnabled().then(

                    function(enabled) {
                        self.alert("Enabled? " + enabled);
                    }
                );
            },
            enableBluetooth() {

                bluetooth.enable().then(

                    function(enabled) {
                        // use Bluetooth features if enabled is true
                    }
                );

            },
            hasBluetoothPermission() {

                bluetooth.hasCoarseLocationPermission().then(

                    function(granted) {}
                );
            },
            requestBluetoothPermission() {

                //ignore the request if the permission has been already granted
                bluetooth.requestCoarseLocationPermission().then(

                    function(granted) {}

                );
            },
            scan() {

                var self = this;
                bluetooth.startScanning({
                    serviceUUIDs: [self.serviceuuid],
                    seconds: 4,
                    onDiscovered: function (peripheral) {
                        console.log("Periperhal found with UUID: " + peripheral.UUID);
                        self.peripheraluuid = peripheral.UUID;
                    },
                    skipPermissionCheck: false,
                }).then(function() {
                    console.log("scanning complete");
                }, function (err) {
                    console.log("error while scanning: " + err);
                });
            },
            connect() {

                if (this.peripheraluuid) {

                    var self = this;
                    this.connecting = true;
                    bluetooth.connect({
                        UUID: self.peripheraluuid,
                        onConnected: function (peripheral) {

                            console.log("Periperhal connected with UUID: " + peripheral.UUID);

                            // the peripheral object now has a list of available services:
                            peripheral.services.forEach(function(service) {

                                console.log("service found: " + JSON.stringify(service));
                            });

                            self.listen();
                        },
                        onDisconnected: function (peripheral) {
                            self.connecting = false;
                            console.log("Periperhal disconnected with UUID: " + peripheral.UUID);
                        }
                    });
                } else {
                    this.alert("Escanea primero los dispositivos");
                }
            },
            disconnect() {

                if (this.peripheraluuid) {

                    var self = this;
                    bluetooth.disconnect({
                        UUID: self.peripheraluuid
                    }).then(function () {

                        self.connecting = false;
                        self.listening = false;
                        console.log("disconnected successfully");
                    }, function (err) {
                        // in this case you're probably best off treating this as a disconnected peripheral though
                        console.log("disconnection error: " + err);
                    });
                }
            },
            listen() {

                console.log("Starting listener...");
                var self = this;
                bluetooth.startNotifying({
                    peripheralUUID: self.peripheraluuid,
                    serviceUUID: self.serviceuuid,
                    characteristicUUID: self.characteristicuuid,
                    onNotify: function (result) {

                        var data = String.fromCharCode.apply(null, new Uint8Array(result.value));

                        console.log("read: " + data);

                        var dataObject = JSON.parse(data);

                        self.connecting = false;
                        self.cadence = dataObject.cadence;
                        // self.timestamp = dataObject.timestamp;
                    }

                }).then(function() {

                    console.log("subscribed for notifications");
                    self.listening = true;
                }, function (err) {

                    self.connecting = false;
                    self.listening = false;
                    console.log("error listening: " + err);
                });
            },
            alert(message) {

                return alert({
                    title: this.appName,
                    okButtonText: "Ok",
                    message: message
                });

            }
        }
    }
</script>

<style scoped>
    ActionBar {
        background-color: #53ba82;
        color: #ffffff;
        font-size: 20px;
    }

    .title {
        vertical-align: center;
        text-align: center;
        font-size: 30px;
        color: #333333;
    }

    .number {
        vertical-align: center;
        text-align: center;
        font-size: 50px;
        color: #333333;
    }
</style>
